;-----------------------------------------------------------------------------
; Initialized data
;-----------------------------------------------------------------------------
.data
	AppName		db	"Neural Networks: Digital brain 2",0
	ClassName	db	"NNDigiBrain32",0


	backRect	RECT	<0,0,WINDOW_WIDTH,WINDOW_HEIGHT>
	valuesRect	RECT	<0,TABLET_HEIGHT*2,RESAMPLE_SMALL_WIDTH*2,RESAMPLE_SMALL_HEIGHT*2>
	
	graphsRect	RECT	<0,0,GRAPH_SMALL_WIDTH*2,GRAPH_SMALL_HEIGHT*2>
	
	bigBI		BITMAPINFOHEADER <SIZEOF BITMAPINFOHEADER, \
									RESAMPLE_SMALL_WIDTH*2, -RESAMPLE_SMALL_HEIGHT*2,\
									1, 32, BI_RGB, 0, 0,0,0,0>
									
	SmallBI		BITMAPINFOHEADER <SIZEOF BITMAPINFOHEADER, \
									RESAMPLE_SMALL_WIDTH, -RESAMPLE_SMALL_HEIGHT,\
									1, 32, BI_RGB, 0, 0,0,0,0>
	
	BGraphBI	BITMAPINFOHEADER <SIZEOF BITMAPINFOHEADER, \
									GRAPH_SMALL_WIDTH*2, -GRAPH_SMALL_HEIGHT*2,\
									1, 32, BI_RGB, 0, 0,0,0,0>
									
	SGraphBI	BITMAPINFOHEADER <SIZEOF BITMAPINFOHEADER, \
									GRAPH_SMALL_WIDTH, -GRAPH_SMALL_HEIGHT,\
									1, 32, BI_RGB, 0, 0,0,0,0>
	
	oldX		dd	-1
	oldY		dd	-1
	oldMeasureX dd	-1
	oldMeasureY	dd	-1

	curPoint	dd	0
	
	CharNetInfo	NNINFO	<NNET_INPUTS,NNET_OUTPUTS,NNET_HIDDENLAYERS,NNET_HIDDENSIZE>	
	
	r3600		real4 3600.0
	r100		real4 100.0
	r50			real4 50.0
	r10000		real4 10000.0
	fontCourier	db	"Courier New",0
	
	lbTabStops	dd	18

	introText	db 0
	
	classButton	db	"button",0
	textTrain	db	"Training mode",0
	textRun		db	"Run mode",0
	
	
	trainDirF	db	"train_sets\*.tdat",0
	trainDir	db	"train_sets\",0
	
	formatResultList	db	9, "%lu%%",0
	
	dwSelectedChar	dd	1	; Selected character in train mode (1=A)
	
	
	errOpenTrainFile		db	"Error: couldn't open train data file.",0
	errInvalidTDATFile		db	"Error: invalid train data file.",0
	errNotEnoughTrainData	db	"Error: some characters are not set yet.",0
	errNewFileFirst			db	"Error: open or create a new train data file first.",0
	errOpenFile				db	"Error: couldn't open file.",0
	errSaveFile				db	"Error: couldn't save file.",0
	errInvalidBrain			db	"Error: invalid brain data in file.",0
	filterBrain				db	"Brain files (*.brain)",0,"*.brain",0,0
	brainTitleSave			db	"Save brain data...",0
	brainTitleLoad			db	"Load brain data...",0
	
.data?
hBackDC		dd		?
hBackBmp	dd		?

hCaptionDC	dd		?
hCaptionBmp dd		?

hResultDC	dd		?
hResultBmp	dd		?

hGraphsBackDC dd	?
hGraphsBackBmp dd	?

hBGraphDC	dd	?
hBGraphBmp	dd	?
pBGraphBmp	dd	?

hSGraphDC	dd	?
hSGraphBmp	dd	?
pSGraphBmp	dd	?

hGraphPen	dd	?
hGraphBrush	dd	?
hGreyPen	dd	?

hBigDC		dd		?
hBigBitmap	dd		?
pBigBitmap	dd		?

hSmallDC	dd		?
hSmallBitmap dd		?
pSmallBitmap dd		?

hBigPen		dd		?
hCourierFont dd		?

hBlueBrush	dd		?

inputArray	dd		TRAIN_SAMPLES*2 dup (?) ;sin and cos of angles
								 			; first TRAIN_SAMPLES sin values,
								 			; then TRAIN_SAMPLES cos values

outputArray			dd		26 dup (?)
recognizedOutput	dd		26  dup (?)

angleArray	dd		MAX_POS_SAMPLES dup (?)

posArray	POINT	MAX_POS_SAMPLES dup (<?>)
curPosIdx	dd		? ; index in posArray

resultText	db		128 dup (?)


lpCharNet	dd		?


dwCurMode	dd		?		; CURMODE_RUN or CURMODE_TRAIN



;-------- window

hRunDlg			dd		?
hTrainDlg		dd		?


; --------- drawing & result

dwResult	dd		? ;0 if no result, 1,2,3,4:A,B,C,D
bDrawing	dd		? ;set if currently drawing

bResTxtChanged 	dd	?

pCurTDAT		dd	?

hCurTDATFile	dd	?